VERSION 5.00
Object = "{447880A9-6A37-43B3-A92E-F125FFBE2493}#2.0#0"; "IngotGridCtl.dll"
Object = "{9F4EED48-8EC7-4316-A47D-F6161874E478}#2.0#0"; "IngotButtonCtl.dll"
Begin VB.Form frmViewData 
   BackColor       =   &H00FFFFFF&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   2400
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   2400
   BeginProperty Font 
      Name            =   "AFPalm"
      Size            =   9
      Charset         =   2
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   160
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   160
   StartUpPosition =   2  'CenterScreen
   Begin IngotButtonCtl.AFButton btnBack 
      Height          =   210
      Left            =   0
      OleObjectBlob   =   "frmViewData.frx":0000
      TabIndex        =   1
      Top             =   2130
      Width           =   450
   End
   Begin IngotGridCtl.AFGrid grdView 
      Height          =   2100
      Left            =   0
      OleObjectBlob   =   "frmViewData.frx":0049
      TabIndex        =   0
      Top             =   0
      Width           =   2295
   End
End
Attribute VB_Name = "frmViewData"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit
'************************************************************
'*
'*  FUNCTION: btnBack_Click
'*
'*  DESCRIPTION: Close this form and return to the main form.
'*
'*  PARAMETERS: None
'*
'*************************************************************
Private Sub btnBack_Click()
   'hide this form and show the main form
   frmViewData.Hide
   frmMain.Show
End Sub
'************************************************************
'*
'*  FUNCTION: LoadData
'*
'*  DESCRIPTION: Opens the database created by calling DBSLibFuser,
'*              and populates the grid control with the results.
'*
'*  PARAMETERS: None
'*
'*************************************************************
Public Sub LoadData()
   'Each field in a record is identified by its unique
   'number, type, and length
   Dim nFieldNum As Long
   Dim nFieldType As Long
   Dim nFieldLen As Long
     
   'Variables for looping through the schema definition string
   'and picking off the field number, type, and length
   Dim nFieldDefIndex As Integer
   Dim sFieldDef As String
   Dim lFieldDefOffset As Long
   Dim lFieldDefLen As Long
   Dim afFieldType As tFieldTypes
   lFieldDefLen = 6

   'Fields from the database which are displayed in
   'the grid control
   Dim strLastName As String
   Dim strFirstName As String
   Dim strPhone As String
   Dim strEmail As String
   Dim nID As Long

   'Number of rows in the grid control
   Dim nRows As Integer
      
   'Open the database and verify
   g_lDB = PDBOpen(Byfilename, g_DBStruct.dbName, 0, 0, 0, 0, 0)
   
   If g_lDB = 0 Then
      MsgBox "Could not open database " + g_DBStruct.dbName
      Exit Sub
   End If

   'Define our database schema
   'Start by setting the number of fields
   PDBSetNumFields g_lDB, g_DBStruct.nNumFields

   'For each field, loop through the schema definition
   'string, picking off the fiel number, type, and length
   For nFieldDefIndex = 1 To g_DBStruct.nNumFields
           
      lFieldDefOffset = (nFieldDefIndex - 1) * lFieldDefLen + 1
      
      'Field definition in the form: num, type, len
      sFieldDef = Mid(g_DBStruct.Schema, lFieldDefOffset, lFieldDefLen)
              
      'Pick off the field number
      nFieldNum = CLng(Mid(sFieldDef, 1, 1))
           
      'Pick off the field type
      nFieldType = CLng(Mid(sFieldDef, 3, 1))
                      
      'Pick off the field length
      nFieldLen = CLng(Mid(sFieldDef, 5, 1))
           
      'Map the field type to its corresponding AppForge type
      Select Case (nFieldType)
         Case DBS_TYPE_BOOL
            afFieldType = eBooleanField
              
         Case DBS_TYPE_BYTE
            afFieldType = eByteField
         
         Case DBS_TYPE_DATE
            afFieldType = eDateField
              
         Case DBS_TYPE_FLOAT
            afFieldType = eFloatField
              
         Case DBS_TYPE_INT
            afFieldType = eIntegerField
             
         Case DBS_TYPE_LONG
            afFieldType = eLongField
              
         Case DBS_TYPE_STR
            afFieldType = eStringField
              
         Case Else
            MsgBox "Invalid field type!"
              
      End Select
           
      'Now set this field's type in the AppForge database schema
      PDBSetFieldType g_lDB, nFieldNum, afFieldType, nFieldLen
                
   Next


    'Sort the database by last name
    PDBSetSortFields g_lDB, LNG_EMP_LASTNAME

   'Get the total number of rows in the grid
   nRows = grdView.Rows
    
   'Hide the grid so it will draw faster
   grdView.Visible = False
   'Remove any existing rows from the grid
   While Not (grdView.Rows = 0)
      grdView.RemoveItem (0)
      grdView.Refresh
      nRows = grdView.Rows
   Wend

   'Format the grid's column widths
   grdView.ColWidth(0) = 200
    
   'target the left column, so that as cell tag
   'properties are set below, they are set for the
   'left cell in each row
   grdView.Col = 0
    
   'Start with the first record in the database
   PDBMoveFirst g_lDB

   'Loop through each record in the database, adding it
   'to the grid control.
   While Not (PDBEOF(g_lDB) = True)
    
        'Get the employee's last name
        PDBGetField g_lDB, LNG_EMP_LASTNAME, strLastName
        
        'Get the employee's first name
        PDBGetField g_lDB, LNG_EMP_FIRSTNAME, strFirstName
        
        'Add to the grid in the form "Last, First"
        grdView.AddItem strLastName + ", " + strFirstName, -1
            
        'Select the row just added to the grid
        grdView.Row = (grdView.Rows - 1)
        
        'Select the row's height
        grdView.RowHeight(grdView.Row) = 15
        
        'Get the employee's phone
        PDBGetField g_lDB, LNG_EMP_PHONE, strPhone
        
        'Add to the grid
        grdView.AddItem "     " + strPhone, -1
                        
        'Select the row just added to the grid
        grdView.Row = (grdView.Rows - 1)
        
        'Select the row's height
        grdView.RowHeight(grdView.Row) = 15
                        
                        
        'Get the employee's email
        PDBGetField g_lDB, LNG_EMP_EMAIL, strEmail
        
        'Add to the grid
        grdView.AddItem "     " + strEmail, -1
                        
        'Select the row just added to the grid
        grdView.Row = (grdView.Rows - 1)
        
        'Select the row's height
        grdView.RowHeight(grdView.Row) = 15
                        
                        
        'Get the employee's ID
        PDBGetField g_lDB, LNG_EMP_ID, nID
        
        'Add to the grid
        grdView.AddItem "     " + "ID: " + CStr(nID), -1
                        
        'Select the row just added to the grid
        grdView.Row = (grdView.Rows - 1)
        
        'Select the row's height
        grdView.RowHeight(grdView.Row) = 15
                        
        'Set the cell's current font
        grdView.FontStyle = 1
                
        'Go to the next record in the database
        PDBMoveNext g_lDB
    Wend
   
   'Set the grid visible
   grdView.Visible = True

   'Close the database
   PDBClose (g_lDB)
   
End Sub
